clc
clear all
close all

fid=fopen('FSM-Output-new5.txt','rt');
for i=1:3,    fgetl(fid), end;
AvailableFleet=fscanf(  fid,  '%g',   [1, 6]  )'

fid2=fopen('DataIG-new5.txt','rt');
%nShipTypes=fscanf(  fid2,  '%g',   [1, inf]  )';
for i=1:16,    fgetl(fid2), end;
Node_st=fscanf(  fid2,  '%g',   [4, 6]  )'

nVessels=sum(AvailableFleet);
nShipTypes=6;
nNodes=4;

Fleet2=zeros(nShipTypes,nVessels);
for i=1:nShipTypes
    if i==1
        temp=ones(1,AvailableFleet(i));
        Fleet2(1,1:length(temp))=temp;
    end
    temp=ones(1,AvailableFleet(i));
    if i>1
        Fleet2(i,sum(AvailableFleet(1:i-1))+1:sum(AvailableFleet(1:i)))=temp;
        temp=0;
    end
end


fclose(fid);
Start=zeros(nShipTypes,nNodes);
Fleet2
%Node_st
AvailableFleet


rowEndVals = cumsum(AvailableFleet);
totalRows = rowEndVals(end);
totalCols = size(Node_st,2);

Node_v = zeros(totalRows, totalCols);

prevRowEnd = 0;

for i = 1:length(AvailableFleet)
    thisRowStart = prevRowEnd + 1;
    Node_v(thisRowStart:rowEndVals(i),:) = ...
    repmat(Node_st(i,:), AvailableFleet(i), 1);
    prevRowEnd = rowEndVals(i);
end

%Node_v
Start = zeros(nVessels,nNodes);

for i = 1:sum(nVessels)
    for j = 1:nNodes
        if Node_v(i,j)==1;
            Start(i,j) = rand;
        else 
            Start(i,j) = 0;
        end
    end
end
B=(max(Start'))';
C=Start;

for i = 1:sum(nVessels)
    for j = 1:nNodes
        if C(i,j)==max(B(i));
            Start(i,j) = 1;
        else 
            Start(i,j) = 0;
        end
    end
end
%Start
max(Start)

Consumption =[
           5.0        5.0        5.0
        1012.8     1119.3     1278.7
         675.2      746.2      874.9
        1308.2     1492.4     1682.5
        1012.8     1119.3     1278.7
           5.0        5.0        5.0
         801.8      906.1     1076.8
         759.6      852.8     1009.5
         675.2      746.2      874.9
         801.8      906.1     1076.8
           5.0        5.0        5.0
         590.8      692.9      807.6
        1308.2     1492.4     1682.5
         759.6      852.8     1009.5
         590.8      692.9      807.6
           5.0        5.0        5.0
           5.0        5.0        5.0
        1156.8     1199.1     1286.3
         771.2      799.4      880.1
        1494.2     1598.8     1692.5
        1156.8     1199.1     1286.3
           5.0        5.0        5.0
         915.8      970.7     1083.2
         867.6      913.6     1015.5
         771.2      799.4      880.1
         915.8      970.7     1083.2
           5.0        5.0        5.0
         674.8      742.3      812.4
        1494.2     1598.8     1692.5
         867.6      913.6     1015.5
         674.8      742.3      812.4
           5.0        5.0        5.0
           5.0        5.0        5.0
        1212.0     1215.9     1259.7
         808.0      810.6      861.9
        1565.5     1621.2     1657.5
        1212.0     1215.9     1259.7
           5.0        5.0        5.0
         959.5      984.3     1060.8
         909.0      926.4      994.5
         808.0      810.6      861.9
         959.5      984.3     1060.8
           5.0        5.0        5.0
         707.0      752.7      795.6
        1565.5     1621.2     1657.5
         909.0      926.4      994.5
         707.0      752.7      795.6
           5.0        5.0        5.0
           6.1        6.1        6.1
         883.2      892.5      934.8
         588.8      595.0      639.6
        1140.8     1190.0     1230.0
         883.2      892.5      934.8
           6.1        6.1        6.1
         699.2      722.5      787.2
         662.4      680.0      738.0
         588.8      595.0      639.6
         699.2      722.5      787.2
           6.1        6.1        6.1
         515.2      552.5      590.4
        1140.8     1190.0     1230.0
         662.4      680.0      738.0
         515.2      552.5      590.4
           6.1        6.1        6.1
           8.5        8.5        8.5
        1416.0     1509.9     1641.6
         944.0     1006.6     1123.2
        1829.0     2013.2     2160.0
        1416.0     1509.9     1641.6
           8.5        8.5        8.5
        1121.0     1222.3     1382.4
        1062.0     1150.4     1296.0
         944.0     1006.6     1123.2
        1121.0     1222.3     1382.4
           8.5        8.5        8.5
         826.0      934.7     1036.8
        1829.0     2013.2     2160.0
        1062.0     1150.4     1296.0
         826.0      934.7     1036.8
           8.5        8.5        8.5
           7.5        7.5        7.5
        1214.4     1272.6     1379.4
         809.6      848.4      943.8
        1568.6     1696.8     1815.0
        1214.4     1272.6     1379.4
           7.5        7.5        7.5
         961.4     1030.2     1161.6
         910.8      969.6     1089.0
         809.6      848.4      943.8
         961.4     1030.2     1161.6
           7.5        7.5        7.5
         708.4      787.8      871.2
        1568.6     1696.8     1815.0
         910.8      969.6     1089.0
         708.4      787.8      871.2
           7.5        7.5        7.5
                                     ];
   
rowEndValsCon = cumsum(AvailableFleet)*16;
totalRowsCon = rowEndValsCon(end);
totalColsCon = size(Consumption,2);

ConsumptionD = zeros(totalRowsCon, totalColsCon);

prevRowEnd = 0;

temp=1;
for i = 1:length(AvailableFleet)
    thisRowStart = prevRowEnd + 1;
    ConsumptionD(thisRowStart:rowEndValsCon(i),:) = ...
    repmat(Consumption(temp:temp+15,:), AvailableFleet(i), 1);
    prevRowEnd = rowEndValsCon(i);
    temp=temp+16;
end

Capacity =[
          7620   3600    550
          7934   3600   1600
          8014   3800   2300
          6300   2000      0
          4474   4500   2800
          6004   7500   4100
                                     ];

rowEndVals = cumsum(AvailableFleet);
totalRowsCap = rowEndVals(end);
totalColsCap = size(Capacity,2)

CapacityD = zeros(totalRowsCap, totalColsCap);

prevRowEnd = 0;

for i = 1:length(AvailableFleet)
    thisRowStart = prevRowEnd + 1;
    CapacityD(thisRowStart:rowEndVals(i),:) = ...
    repmat(Capacity(i,:), AvailableFleet(i), 1);
    prevRowEnd = rowEndVals(i);
end


TotCap = [8000 8500 9000 7000 4500 6000]'


rowEndVals = cumsum(AvailableFleet);
totalRowsTotCap = rowEndVals(end);
totalColsTotCap = size(TotCap,2);

TotCapD = zeros(totalRowsTotCap, totalColsTotCap)
prevRowEnd = 0;
for i = 1:length(AvailableFleet)
    thisRowStart = prevRowEnd + 1;
    TotCapD(thisRowStart:rowEndVals(i),:) = ...
    repmat(TotCap(i,:), AvailableFleet(i), 1);
    prevRowEnd = rowEndVals(i);
end

TotCapD


fid=fopen('RoutingData.txt','wt');
			

    fprintf(fid,'nVessels :');
        fprintf(fid,'%1.0f \n',nVessels);

    fprintf(fid,'Fleet :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',Fleet2');
        fprintf(fid,'   ]\n\n');
    fprintf(fid,'Start :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',Start');
        fprintf(fid,'   ]\n\n');
    fprintf(fid,'Node_v :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',Node_v');
        fprintf(fid,'   ]\n\n');
    fprintf(fid,'ConsumptionD :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',ConsumptionD');
        fprintf(fid,'   ]\n\n');
    fprintf(fid,'CapacityD :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',CapacityD');
        fprintf(fid,'   ]\n\n');
    fprintf(fid,'TotCapD :[\n');
        fprintf(fid,'%14.0f %4.0f %4.0f %4.0f\n',TotCapD');
        fprintf(fid,'   ]\n\n');
        
        
fclose(fid);